/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/08/08
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
GPIỌ
PC13 Ϊ TAMPER šRTC ӻ
PC14  PC15 ֻ LSE š
Դ VDDϵȶϵͳԶл VDD磬PC1315  GPIO ܡ
 PC1315 Ϊ GPIO ʱٶȱ 2MHz £صΪ 30pFҽ
ֹڳĳϣ LED 

*/

#include "debug.h"

/* Global define */
/* Global Variable */

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0
 *
 * @return  none
 */
void GPIO_Toggle_INIT( void )
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOC, ENABLE );

    PWR_BackupAccessCmd( ENABLE );/* ޸RTCͺ󱸼Ĵ*/
    RCC_LSEConfig( RCC_LSE_OFF ); /* رⲿʱ,PC14+PC15ͨIO*/
    BKP_TamperPinCmd(DISABLE);    /* رּ⹦,PC13ͨIO*/

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13| GPIO_Pin_14 | GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
    GPIO_Init( GPIOC, &GPIO_InitStructure );
    PWR_BackupAccessCmd(DISABLE);/* ֹ޸RTCͺ󱸼Ĵ*/
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main( void )
{
//    u8 i = 0;
//    u8 j = 0;
//    u8 k = 0;

    NVIC_PriorityGroupConfig( NVIC_PriorityGroup_2 );
    Delay_Init();
    USART_Printf_Init( 115200 );

    printf( "SystemClk:%d\r\n", SystemCoreClock );
    printf( "GPIO Toggle TEST\r\n" );

    GPIO_Toggle_INIT();

    while( 1 )
    {
        Delay_Ms( 250 );
        if(GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_13)==1)
        {
            printf( "UP\r\n" );
        }
        else
        {
            printf( "DOWN\r\n" );
        }
//        GPIO_WriteBit( GPIOC, GPIO_Pin_13, ( i == 0 ) ? ( i = Bit_SET ) : ( i = Bit_RESET ) );
//        GPIO_WriteBit( GPIOC, GPIO_Pin_14, ( j == 0 ) ? ( j = Bit_SET ) : ( j = Bit_RESET ) );
//        GPIO_WriteBit( GPIOC, GPIO_Pin_15, ( k == 0 ) ? ( k = Bit_SET ) : ( k = Bit_RESET ) );
    }
}
